/*
 * Created on 11.08.2004
 *
 * @author Jens Guenther
 */
package de.unirostock.AbstractFactory.example;


import javax.swing.Icon;

public abstract class ShipFactory 
{
	protected final static String	FILEEXT_BOOK	= "_book.gif";
	protected final static String	FILEEXT_PLAN	= "_plan.gif";
	protected final static String	FILEEXT_HULL	= "_hull.gif";
	protected final static String	FILEEXT_MASTS	= "_masts.gif";
	protected final static String	FILEEXT_SAILS	= "_sails.gif";
	protected final static String	FILEEXT_PHOTO	= "_photo.gif";
	
	protected Icon itsBook;
	protected Icon itsPlan;
	protected Icon itsHull;
	protected Icon itsMasts;
	protected Icon itsSails;
	protected Icon itsPhoto;
	
	public final Icon getBookIcon(){
		return itsBook;
	}
	
	public final Icon getPlanIcon(){
		return itsPlan;
	}
	
	public final Icon getHullIcon(){
		return itsHull;
	}
	
	public final Icon getMastsIcon(){
		return itsMasts;
	}
	
	public final Icon getSailsIcon(){
		return itsSails;
	}
	
	public final Icon getPhotoIcon(){
		return itsPhoto;
	}
	
	public abstract Hull createHull();
	public abstract Masts createMasts();
	public abstract Sails createSails();
	public abstract Ship createShip();
}
